export default class AsyncArray<T> {
    private readonly elements;
    private constructor();
    static from<T>(from: Iterable<T | Promise<T>>): AsyncArray<T>;
    toArray(): Promise<T[]>;
    concat(...vals: (T | Promise<T> | T[] | Promise<T>[])[]): AsyncArray<T>;
    forEach(iterator: (val: T) => void | Promise<void>): Promise<void>;
    every(predicate: (val: T) => boolean | Promise<boolean>): Promise<boolean>;
    some(predicate: (val: T) => boolean | Promise<boolean>): Promise<boolean>;
    map<M>(mapper: (val: T) => M | Promise<M>): AsyncArray<M>;
    filter(predicate: (val: T) => boolean | Promise<boolean>): AsyncArray<T>;
    filterType<R extends T>(predicate: (val: T) => val is R): AsyncArray<R>;
    push(...vals: (T | Promise<T>)[]): number;
    pop(): Promise<T | undefined>;
    unshift(vals: (T | Promise<T>)[]): number;
    shift(): Promise<T | undefined>;
    private next;
}
