export default class Dict<K, V> implements Map<K, V> {
    readonly [Symbol.toStringTag]: string;
    private readonly map;
    constructor(entriesOrMap?: Map<K, V> | Iterable<readonly [K, V]>);
    get size(): number;
    clone(): Dict<K, V>;
    clear(): void;
    computeIfAbsent(key: K, provider: (key: K) => V): V;
    computeIf(key: K, pred: (value: V | undefined) => boolean, provider: (key: K, value: V | undefined) => V): V;
    containsKey(key: K): boolean;
    entries(): IterableIterator<[K, V]>;
    get(key: K): V | undefined;
    getOrThrow(key: K, error?: (key: K) => Error): V;
    getOrDefault(key: K, def: V): V;
    isEmpty(): boolean;
    keys(): IterableIterator<K>;
    put(key: K, value: V): V | undefined;
    putIfAbsentOrThrow(key: K, value: V, error?: (key: K, value: V) => Error): V;
    remove(key: K): V | undefined;
    values(): IterableIterator<V>;
    [Symbol.iterator](): IterableIterator<[K, V]>;
    delete(key: K): boolean;
    forEach(cb: (value: V, key: K, map: Map<K, V>) => void, thisArg?: any): void;
    has(key: K): boolean;
    set(key: K, value: V): this;
}
