export declare type Key = {
    equals(other: unknown): boolean;
    hashCode(): HashCode;
};
export declare type HashCode = bigint | number | string;
export default class StructuralMap<K extends Key, V> implements Map<K, V> {
    readonly [Symbol.toStringTag]: string;
    private readonly map;
    private _size;
    get size(): number;
    [Symbol.iterator](): IterableIterator<[K, V]>;
    clear(): void;
    delete(key: K): boolean;
    entries(): IterableIterator<[K, V]>;
    forEach(callbackfn: (value: V, key: K, map: Map<K, V>) => void, thisArg?: any): void;
    get(key: K): V | undefined;
    has(key: K): boolean;
    keys(): IterableIterator<K>;
    set(key: K, value: V): this;
    values(): IterableIterator<V>;
}
