export default class Ymd {
    private readonly _dt;
    private constructor();
    static nowLocal(): Ymd;
    static nowUTC(): Ymd;
    static fromDaysSinceEpoch(days: number): Ymd;
    static fromDateUTC(date: Date): Ymd;
    static fromDateLocal(date: Date): Ymd;
    static fromObject(obj: {
        year: number;
        month: number;
        day: number;
    }): Ymd;
    static maybeFromISO(raw: string): Ymd | undefined;
    static fromISO(raw: string): Ymd;
    get isValid(): boolean;
    get day(): number;
    get month(): number;
    get year(): number;
    daysSinceEpoch(): number;
    with(obj: {
        year?: number;
        month?: number;
        day?: number;
    }): Ymd;
    compareTo(other: Ymd): number;
    equals(other: unknown): boolean;
    hashCode(): number;
    toLocaleString(locales: string, opt: Intl.DateTimeFormatOptions): string;
    toISO(): string;
    toDateLocal(hour?: number, minute?: number, second?: number, ms?: number): Date;
    toDateUTC(hour?: number, minute?: number, second?: number, ms?: number): Date;
    valueOf(): number;
    [Symbol.toPrimitive](hint: "number" | "string" | "default"): string | number | null;
}
