declare type AbortableChainStageExecutor<I, O> = (lastStageOutput: I, signal: AbortSignal) => O | Promise<O>;
declare type AbortableChainStage<I, ExecAddProps> = {
    add<O>(fn: AbortableChainStageExecutor<I, O>): AbortableChainStage<Awaited<O>, ExecAddProps>;
    exec(): Promise<I> & ExecAddProps;
};
declare type ManagedAbortableChainStageExecAddProps = {
    abort: (reason?: any) => void;
};
export default class AbortableChain implements AbortableChainStage<void, {}> {
    private readonly abortSignal;
    private readonly stages;
    constructor(abortSignal: AbortSignal);
    add<O>(fn: (lastStageOutput: any, signal: AbortSignal) => O | Promise<O>): AbortableChainStage<Awaited<O>, {}>;
    exec(): Promise<any>;
}
export declare class ManagedAbortableChain extends AbortableChain {
    private readonly controller;
    constructor();
    add<O>(fn: (lastStageOutput: any, signal: AbortSignal) => O | Promise<O>): AbortableChainStage<Awaited<O>, ManagedAbortableChainStageExecAddProps>;
    exec(): Promise<any>;
}
export {};
