"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const errorMatches_1 = __importDefault(require("./errorMatches"));
exports.default = (realFn, errorMatch) => {
    return async function (...args) {
        try {
            return await realFn.apply(this, args);
        }
        catch (error) {
            if (errorMatch == undefined || (0, errorMatches_1.default)(error, errorMatch)) {
                return undefined;
            }
            throw error;
        }
    };
};
