import Comparator from "./Comparator";
/**
 * Create a comparator that orders values that pass a predicate before values that do not.
 * Values that fail the predicate are considered equal, while values that pass are compared using the {@param additional} comparator.
 * @param cond predicate to test values against.
 */
declare const _default: <V>(cond: (val: V) => boolean, additional: Comparator<V>) => Comparator<V>;
export default _default;
