"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assertByte_1 = __importDefault(require("./assertByte"));
exports.default = (encoded) => {
    const it = encoded[Symbol.iterator]();
    const firstByte = (0, assertByte_1.default)(it.next().value);
    const isNegative = !!(firstByte & 128);
    let val = BigInt(firstByte & 63);
    let ls = 6n;
    if (!!(firstByte & 64)) {
        while (true) {
            const byte = (0, assertByte_1.default)(it.next().value);
            val |= BigInt(byte & 127) << ls;
            ls += 7n;
            if (!(byte & 128)) {
                break;
            }
        }
    }
    if (isNegative) {
        val = -val;
    }
    return val;
};
