"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const last_1 = __importDefault(require("./last"));
exports.default = (data) => {
    const encoded = new Uint8Array(Math.ceil((8 / 7) * data.byteLength));
    let next = 0;
    let carryBits = 0;
    for (let i = 0; i < data.byteLength; i++) {
        carryBits = i % 7;
        encoded[next++] =
            ((data[i - 1] << (7 - carryBits)) & 0x7f) | (data[i] >>> (carryBits + 1));
        if (carryBits == 6) {
            encoded[next++] = data[i] & 0x7f;
        }
    }
    if (carryBits != 6) {
        encoded[next] = ((0, last_1.default)(data) << (7 - carryBits - 1)) & 0x7f;
    }
    return encoded;
};
