/// <reference types="node" />
/// <reference types="node" />
/// <reference types="node" />
import { Readable } from "stream";
declare type TextEncoding = "ascii" | "utf8" | "utf-8" | "utf16le" | "ucs2" | "ucs-2";
declare type Exec<Encoding extends string | Buffer> = {
    additionalEnv(entries: Map<string, string | number>): Exec<Encoding>;
    additionalEnv(entries: {
        [name: string]: string | number;
    }): Exec<Encoding>;
    binary(): Exec<Buffer>;
    env(name: string, value: string | number): Exec<Encoding>;
    killOnStderr(shouldKill?: boolean | NodeJS.Signals): Exec<Encoding>;
    onStderr(onData: (chunk: Encoding) => void): Exec<Encoding>;
    onStdout(onData: (chunk: Encoding) => void): Exec<Encoding>;
    pidFile(path: string): Exec<Encoding>;
    print(shouldPrintStdoutOrStderr: false): Exec<Encoding>;
    print(shouldPrintStdout: boolean, shouldPrintStderr: boolean): Exec<Encoding>;
    printCmdline(shouldPrintCmdline?: boolean): Exec<Encoding>;
    printStderr(shouldPrint?: boolean): Exec<Encoding>;
    printStdout(shouldPrint?: boolean): Exec<Encoding>;
    stdin(data: ArrayBuffer | Readable | string | Uint8Array): Exec<Encoding>;
    text(encoding?: TextEncoding): Exec<string>;
    throwOnBadStatus(shouldThrow?: boolean): Exec<Encoding>;
    throwOnSignal(shouldThrow?: boolean): Exec<Encoding>;
    timeout(ms: number): Exec<Encoding>;
    workingDir(dir: string): Exec<Encoding>;
    output(withStderr?: boolean, withStdout?: boolean): Promise<Encoding>;
    run(): Promise<void>;
    status(): Promise<number>;
    stream(withStderr?: boolean, withStdout?: boolean): {
        promise: Promise<number>;
        stream: Readable;
    };
};
declare const _default: (cmd: string, ...args: (string | number)[]) => Exec<string>;
export default _default;
