"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// TS does not automatically infer method overrides/implements.
// This function helps with that.
// https://github.com/microsoft/TypeScript/issues/23911.
exports.default = (name, base, overrides, staticOverrides) => {
    const child = overrides.constructor;
    Object.assign(child, staticOverrides);
    Object.defineProperty(child, "name", { value: name });
    child.prototype = Object.assign(Object.create(base.prototype), overrides);
    return child;
};
