"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fakeReadableStream = void 0;
const stream_1 = require("stream");
const asyncTimeout_1 = __importDefault(require("./asyncTimeout"));
const randomInteger_1 = __importDefault(require("./randomInteger"));
const fakeReadableStream = (data, maxWaitTimeMs) => {
    const src = new stream_1.PassThrough();
    (async () => {
        let next = 0;
        while (src.writable && next < data.length) {
            const toWrite = (0, randomInteger_1.default)(0, data.length - next);
            src.write(data.slice(next, next + toWrite));
            next += toWrite;
            await (0, asyncTimeout_1.default)((0, randomInteger_1.default)(0, maxWaitTimeMs));
        }
        // If next < data.length, the stream failed before we could write all bytes.
        if (next == data.length) {
            src.end();
        }
    })();
    return src;
};
exports.fakeReadableStream = fakeReadableStream;
