"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const isJsonValue = (val, cfg) => {
    if (val === null) {
        return true;
    }
    const type = typeof val;
    if (type == "boolean" || type == "string") {
        return true;
    }
    if (type == "number") {
        return !cfg?.rejectNonFiniteNumbers || Number.isFinite(val);
    }
    if (Array.isArray(val)) {
        return val.every((v) => isJsonValue(v, cfg));
    }
    if (type == "object") {
        if (cfg?.useToJSON && typeof val.toJSON == "function") {
            val = val.toJSON();
        }
        return Object.entries(val).every(([k, v]) => typeof k == "string" && isJsonValue(v, cfg));
    }
    return false;
};
exports.default = isJsonValue;
