"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const promises_1 = require("fs/promises");
exports.default = async (path, opts) => {
    try {
        const stats = await (opts?.lstat ? promises_1.lstat : promises_1.stat)(path, {
            bigint: opts?.bigint,
        });
        return stats;
    }
    catch (e) {
        if (e.code === "ENOENT") {
            return undefined;
        }
        throw e;
    }
};
