declare type EventHandlers = {
    [eventName: string]: (arg: any) => any;
};
declare type EventEmitter<T extends EventHandlers> = {
    [E in keyof T]: {
        on(eventName: E, cb: T[E]): void;
        off(eventName: string, cb: Function): void;
    } | {
        addEventListener(eventName: E, cb: T[E]): void;
        removeEventListener(eventName: string, cb: Function): void;
    };
}[keyof T];
declare type Builder<Outputs extends any[]> = {
    add<T extends EventHandlers>(eventEmitter: EventEmitter<T>, handlers: T): Builder<{
        [E in keyof T]: ReturnType<T[E]>;
    }[keyof T]>;
    wait(): Promise<Outputs[number]>;
};
declare const _default: () => Builder<[]>;
export default _default;
