"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const mapNonNegative_1 = __importDefault(require("./mapNonNegative"));
/**
 * Return the index of the dot representing the extension of the provided
 * file path. If no extension exists, return -1.
 */
exports.default = (path, separator = path_1.sep) => {
    const lastSepPos = path.lastIndexOf(separator) + 1;
    const dotPos = path.slice(lastSepPos).lastIndexOf(".");
    return (0, mapNonNegative_1.default)(dotPos, (dotPos) => lastSepPos + dotPos) ?? -1;
};
