"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const degToRad_1 = __importDefault(require("./degToRad"));
const labToLch_1 = __importDefault(require("./labToLch"));
const mapToArray_1 = __importDefault(require("./mapToArray"));
const rgbToXyz_1 = __importDefault(require("./rgbToXyz"));
const xyzToLab_1 = __importDefault(require("./xyzToLab"));
// Calculate the perceived brightness of an RGB colour on a scale from 0 (darkest) to 1 (brightest).
exports.default = (r, g, b) => {
    const [l, c, h] = (0, labToLch_1.default)(...(0, xyzToLab_1.default)(...(0, mapToArray_1.default)((0, rgbToXyz_1.default)(r, g, b), (v) => v * 100)));
    return ((l +
        (2.5 - 0.025 * l) *
            (0.116 * Math.abs(Math.sin((0, degToRad_1.default)((h - 90) / 2))) + 0.085) *
            c) /
        100);
};
