"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const LinkedList_1 = __importDefault(require("./LinkedList"));
async function* default_1(...iterables) {
    const promises = new LinkedList_1.default();
    for (const iterable of iterables) {
        const iterator = iterable[Symbol.asyncIterator]();
        const node = promises.append(iterator.next().then((e) => ({ ...e, iterator, getNode: () => node })));
    }
    while (!promises.isEmpty()) {
        const p = await Promise.race(promises);
        const n = p.getNode();
        if (p.done) {
            n.detach();
        }
        else {
            yield p.value;
            n.setValue(p.iterator
                .next()
                .then((e) => ({ ...e, iterator: p.iterator, getNode: p.getNode })));
        }
    }
}
exports.default = default_1;
