"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const chunker_1 = __importDefault(require("./chunker"));
async function* default_1(input, size, 
// This is default false by assumption that most people will want to keep all data and not just silently throw away a chunk. Even if they require all exact-size chunks, they should still receive all chunks and make an assertion on each chunk.
discardRemaining = false) {
    const chunker = new chunker_1.default(size);
    for await (const chunk of input) {
        yield* chunker.push(chunk);
    }
    const rem = chunker.takeRemaining();
    if (!discardRemaining && rem.byteLength) {
        yield rem;
    }
}
exports.default = default_1;
