"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assertExists_1 = __importDefault(require("./assertExists"));
const assertNonNegative_1 = __importDefault(require("./assertNonNegative"));
exports.default = () => {
    let pending = 0;
    let resolver;
    let rejecter;
    return Object.assign(new Promise((resolve, reject) => {
        resolver = resolve;
        rejecter = reject;
    }), {
        done: () => {
            if (!(0, assertNonNegative_1.default)(--pending)) {
                (0, assertExists_1.default)(resolver)();
            }
        },
        add: (count = 1) => (pending += count),
        error: (err) => (0, assertExists_1.default)(rejecter)(err),
    });
};
